## 代码规范

```
apiList:语义化接口名称  例如：getUser deleteUser updateUser addUser ...
目录结构：（1）views里面的每一个page是按照路由来划分的 命名规则 xxx.vue xxx.ts
         （2）src下每一个模块都要尽量写index统一导出，这样解耦清晰
         （3）assets---静态资源
              components---公共组件
              hooks---components的修饰函数
              router---路由文件
              store---vuex
              util---通用方法
              views---页面
目录命名规则 （1）paramCase (-)
            （2）变量写小驼峰
            （3）组件文件夹写小驼峰，组件名称写大驼峰
main.ts 尽量不要写逻辑 逻辑抽离出去
vuex  除了基础框架内的东西 其他的modules要独立一个ts文件
route detail是用来承载除了路由下的其他静态路由

```

## 依赖库

```bash
node 14.15.4

npm 6.14.10

vue3 + antDesignVue2.x + route4 + vuex4 + axios
```

## 安装

```bash
npm install 安装依赖

```

## 使用

```bash
npm run serve

```

### 打包

```bash
npm run build
```

### 打包

```bash
npm run build   开发
npm run build:prod  生产
```

### 检测

```bash
npm run lint 检察代码是否符合eslint规范

```

### 格式化

```bash
npm run lint:prettier 按照prettier格式化
npm run lint:stylelint 格式化CSS
```

## 已完成功能

- [x] 目录
- [x] 登录和注销
- [x] 用户管理
- [x] 可分配权限的角色管理
- [x] 可管理用户的部门管理
- [x] 基于后台路由权限的菜单管理
- [x] 完全动态的路由设置
- [x] 可折叠侧边栏
- [x] 可拖拽菜单自定义侧边栏
- [x] 多标签页模式/全局控制
- [x] 菜单搜索
- [x] 页面加载 loading
- [x] 弹窗扩展（自定义组合模板的弹窗）
- [x] hooks 封装
- [x] 表单组件(eyas 自由组装 二次封装)
- [x] 验证码登录
- [x] 可拖动树组件
- [x] 表格组件
- [x] 全局错误处理

## 待开发的功能

- [ ] 黑暗主题
- [ ] 主题配置



执行后的目录包含所有改动文件的目录结构

## 加入我们

把手科技内部强大的后台基础框架，不得侵权

## 增量包配置命令及使用方法

进入项目 git 的根目录

进入 git bash 执行如下命令
```
git diff 【new】 【old】 --name-only | xargs tar -czvf update.tar.gz
```
其中 reversion number 在 git tree 中可以 copy 【可以只取前 7 位 】