import { createApp } from 'vue'

import App from './App.vue'
import router from './router'
import store from './store'

import { directive, globalComponents } from './global/'

import { apiList, Server, interceptor } from './api'

import { keepQuery } from './mixins/mixin.js'

import { tableSorter, ruleCheck, ruleCancel, paginationFn, handleModel } from './hooks'

import {
    reg_zh,
    reg_symbols,
    getUrlParam,
    downloadFile,
    formatTime,
    ifOpen,
    assignmentOpen,
    findParentData,
} from './util'

import {
    EyasInput,
    EyasPassword,
    EyasSelect,
    EyasTree,
    EyasTextarea,
    EyasNumber,
    EyasTreeCheck,
    EyasInputNumber,
    Table,
    Screen,
    TableActionButton,
    Pagination,
    Modal,
    PageMessage,
    Sidebar,
    Header,
    Tab,
    SearchTree,
    EyasRadio,
    EyasRangePicker,
    DragTreeTable,
    WangEditor,
} from './components'

import 'ant-design-vue/dist/antd.css'
import './assets/css/index.less'

class creatEyas {
    constructor() {
        this.app = createApp(App)
        this.router = router
        this.store = store
        this.init()
    }
    init() {
        interceptor(this.app, this.router)
        directive(this.app, this.store)
        globalComponents(this.app)
        this.app.use(this.store).use(this.router).mount('#app')
    }
}

export {
    ifOpen,
    assignmentOpen,
    findParentData,
    creatEyas,
    router,
    store,
    apiList,
    Server,
    keepQuery,
    tableSorter,
    ruleCheck,
    ruleCancel,
    paginationFn,
    handleModel,
    reg_zh,
    reg_symbols,
    getUrlParam,
    downloadFile,
    formatTime,
    EyasInput,
    EyasPassword,
    EyasSelect,
    EyasTree,
    EyasTextarea,
    EyasNumber,
    EyasTreeCheck,
    EyasInputNumber,
    Table,
    Screen,
    TableActionButton,
    Pagination,
    Modal,
    PageMessage,
    Sidebar,
    Header,
    Tab,
    SearchTree,
    EyasRadio,
    EyasRangePicker,
    DragTreeTable,
    WangEditor,
}
