/**
 * @param {type} str 验证中文
 */
export function reg_zh(str) {
    if (typeof str !== 'string') {
        throw new Error('类型错误，无法校验')
    }

    const reg = /^[\u4e00-\u9fa5]+$/
    return reg.test(str)
}

export function reg_symbols(str) {
    if (typeof str !== 'string') {
        throw new Error('类型错误，无法校验')
    }

    const regEn = /[`~!@#$%^&*()_+-=<>?:"{},.\\/;'[\]]/im
    const regCn = /[·！#￥（——）：；“”‘、，|《。》？、【】[\]]/im

    return regEn.test(str) || regCn.test(str)
}
