import { useRoute } from 'vue-router'

/**
 * 获取路由参数 path query meta
 */
export function getUrlParam() {
    const route = useRoute()
    return {
        path: route.path,
        query: route.query,
        meta: route.meta,
    }
}

export function downloadFile(res) {
    const fileName = res.headers['content-disposition'].split(';')[1].split('=')[1]
    const url = window.URL.createObjectURL(new Blob([res.data]))
    const link = document.createElement('a')
    link.style.display = 'none'
    link.href = url
    link.setAttribute('download', decodeURIComponent(fileName))
    document.body.appendChild(link)
    link.click()
}

export function formatTime(data) {
    const d = new Date(data)
    const year = d.getFullYear()
    const month = d.getMonth() + 1
    const day = d.getDate()
    const hour = d.getHours()
    const minute = d.getMinutes()
    const second = d.getSeconds()

    const formatNumber = (n) => {
        n = n.toString()
        return n[1] ? n : '0' + n
    }

    return (
        [year, month, day].map(formatNumber).join('-') +
        ' ' +
        [hour, minute, second].map(formatNumber).join(':')
    )
}

export function ifOpen(treeData, id) {
    const whoOpen: any = []
    recursion(treeData)
    function recursion(treeData) {
        if (treeData.open) {
            whoOpen.push(treeData[id])
        }
        if (treeData.children) {
            treeData.children.forEach((element) => {
                recursion(element)
            })
        }
    }
    return whoOpen
}

export function assignmentOpen(whoOpen, treeData, id) {
    recursion(treeData)
    function recursion(treeData) {
        if (whoOpen.includes(treeData[id])) {
            treeData.open = true
        }
        if (treeData.children) {
            treeData.children.forEach((element) => {
                recursion(element)
            })
        }
    }
}
export function findParentData(id, data, nameFont) {
    let nodes = []
    getParentNodes(id, data)
    function getParentNodes(id, tree) {
        _getParentNodes([], id, tree)
    }

    function _getParentNodes(his, targetId, tree) {
        tree.some((list) => {
            const children = list.children || []
            if (list[nameFont] == targetId) {
                nodes = his
                return true
            } else if (children.length > 0) {
                const history = [...his]
                history.push(list[nameFont])
                return _getParentNodes(history, targetId, children)
            }
        })
    }
    return nodes
}
