import { apiList, Server, handleModel, paginationFn } from 'eyas-bashou-admin'
import { message } from 'ant-design-vue'

function hooks(initData) {
    const { columns, tableData, modalData, paginationData } = initData
    //获取当前条件下的列表数据
    const getDatabaseList = () => {
        const data: any = {
            method: 'GET',
            url: apiList.dbBackupPage,
            config: {
                params: {
                    pageSize: paginationData.pageSize,
                    pageNo: paginationData.pageNo || 1,
                },
            },
        }

        Server.Axios(data).then((res: any) => {
            res.data.data.list.forEach((element, index) => {
                element.backupTypeName = element.backupType === '1' ? '手动备份' : '自动备份'
                element.index = (paginationData.pageNo - 1) * 10 + index + 1
            })
            tableData.value = res.data.data.list
            updateTotal(res.data.data.total)
        })
    }

    //分页操作
    const { pageChange, onShowSizeChange, updateTotal } = paginationFn(
        getDatabaseList,
        paginationData
    )

    //弹窗的打开和启用以及弹窗的状态
    const { modalState, cancelModal, openModal } = handleModel(modalData)

    function backUpOpenModal(modalState) {
        openModal(modalState.key, modalState.title)
    }
    //备份
    const backupFn = () => {
        Server.Axios({
            method: 'POST',
            url: apiList.manual,
            config: {
                data: {
                    backupMemo: modalData.info.value,
                },
            },
        }).then((res: any) => {
            message.success('手动备份成功', 4)
            getDatabaseList()
            cancelModal()
        })
    }

    return {
        columns,
        tableData,
        modalData,
        modalState,
        backUpOpenModal,
        openModal,
        getDatabaseList,
        cancelModal,
        backupFn, //添加用户
        pageChange, //点击页码时
        onShowSizeChange,
        paginationData,
    }
}
export { hooks }
