import { apiList, Server, paginationFn, downloadFile } from 'eyas-bashou-admin'
import { message } from 'ant-design-vue'

function hooks(initData) {
    const {
        tableData, //列表搜索条件
        columns, //列表数据
        screenData, //筛选模糊查询数据
        paginationData, //分页
    } = initData

    //获取当前条件下的列表数据
    const userList = () => {
        let data: any = {
            method: 'POST',
            url: apiList.logListPage,
            config: {
                data: {
                    username: screenData.username.value || '',
                    pageSize: paginationData.pageSize,
                    pageNo: paginationData.pageNo,
                },
            },
        }

        Server.Axios(data).then((res: any) => {
            //添加索引字段以及把创建时间改为北京时间
            res.data.list.forEach((element, index) => {
                element.index = (paginationData.pageNo - 1) * paginationData.pageSize + index + 1
            })
            //填充列表数据和总条数
            tableData.value = res.data.list
            updateTotal(res.data.total)
        })
    }

    //分页操作
    const { pageChange, onShowSizeChange, updateTotal } = paginationFn(userList, paginationData)

    //增加弹窗前触发的钩子
    const beforeAddOpen = () => {
        let data: any = {
            method: 'POST',
            url: apiList.downLoad,
            config: {
                data: {
                    username: screenData.username.value || '',
                },
                responseType: 'blob',
            },
        }

        Server.Axios(data).then((res: any) => {
            if (res) {
                downloadFile(res)
            } else {
                message.error('下载失败')
            }
        })
    }

    //查询用户
    const clickSearch = (data) => {
        paginationData.pageNo = 1
        userList()
    }

    return {
        columns,
        screenData,
        tableData, //列表数据
        userList, //获取当前条件下的列表数据
        pageChange, //点击页码时
        onShowSizeChange,
        beforeAddOpen,
        paginationData,
        clickSearch,
    }
}
export { hooks }
