import {
    apiList,
    Server,
    handleModel,
    ifOpen,
    assignmentOpen,
    findParentData,
} from 'eyas-bashou-admin'
import { message } from 'ant-design-vue'
//修改菜单
function hooks(initData) {
    const editFn = (() => {
        // 编辑的方法
        function editMenuFn() {
            const data: any = {
                method: 'PUT',
                url: apiList.menu,
                config: {
                    data: {},
                },
            }

            data.config.data.type = modalTypeData.value
            data.config.data.menuId = modalTypeData.id
            switch (modalTypeData.value) {
                case '0':
                    data.config.data.menuName = catalogData.catalogTitle.value
                    data.config.data.url = catalogData.catalogRoute.value
                    data.config.data.valid = catalogData.catalogVisible.value
                    data.config.data.parentId = catalogData.catalogSuperior.value
                    data.config.data.sort = catalogData.catalogSort.value
                    data.config.data.icon = catalogData.catalogIcon.value
                    break
                case '1':
                    data.config.data.menuName = menuData.menuTitle.value
                    data.config.data.url = menuData.menuRoute.value
                    data.config.data.valid = menuData.menuVisible.value
                    data.config.data.parentId = menuData.menuSuperior.value
                    data.config.data.sort = menuData.menuSort.value
                    data.config.data.icon = menuData.menuIcon.value
                    break
                case '2':
                    data.config.data.menuName = buttonData.buttonTitle.value
                    data.config.data.url = buttonData.buttonId.value
                    data.config.data.parentId = buttonData.buttonSuperior.value
                    data.config.data.valid = buttonData.buttonVisible.value
                    data.config.data.sort = buttonData.buttonSort.value
                    break
            }

            Server.Axios(data).then((res: any) => {
                message.success('编辑菜单成功', 4)
                cancelModal()
                getMenuTree()
            })
        }

        // 点击修改之前的操作
        function editBefore(item) {
            getMenuButtonTree()
            modalTypeData.value = item.type
            modalTypeData.id = item.menuId
            switch (modalTypeData.value) {
                case '0':
                    catalogData.catalogTitle.value = item.menuName
                    catalogData.catalogRoute.value = item.key
                    catalogData.catalogVisible.value = item.valid
                    catalogData.catalogSuperior.value = item.parentId == '0' ? null : item.parentId
                    catalogData.catalogSort.value = item.sort
                    catalogData.catalogIcon.value = item.icon
                    break
                case '1':
                    menuData.menuTitle.value = item.menuName
                    menuData.menuRoute.value = item.key
                    menuData.menuVisible.value = item.valid
                    menuData.menuSuperior.value = item.parentId == '0' ? null : item.parentId
                    menuData.menuSort.value = item.sort
                    menuData.menuIcon.value = item.icon
                    break
                case '2':
                    buttonData.buttonTitle.value = item.menuName
                    buttonData.buttonId.value = item.key
                    buttonData.buttonSuperior.value = item.parentId == '0' ? null : item.parentId
                    buttonData.buttonVisible.value = item.valid
                    buttonData.buttonSort.value = item.sort
                    break
            }
            openModal('update', '编辑')
        }

        return { editMenuFn, editBefore }
    })()

    const {
        modalTypeData,
        catalogData,
        menuData,
        buttonData,
        screenData,
        whoOpen,
        treeData,
    } = initData

    //弹窗的打开和启用以及弹窗的状态
    const { modalState, cancelModal, openModal } = handleModel({}, initialization)

    // 获取菜单树全部数据
    function getMenuTree(id = 0) {
        treeData.lists.forEach((treeData) => {
            whoOpen.value = [...whoOpen.value, ...ifOpen(treeData, 'menuId')]
        })

        const data: any = {
            method: 'GET',
            url: apiList.organizationTree,
            config: {
                params: {},
            },
        }

        if (screenData.valid.value !== null) {
            data.config.params.valid = screenData.valid.value
        }
        if (screenData.menuName.value !== null) {
            data.config.params.menuName = screenData.menuName.value
        }

        Server.Axios(data).then((res: any) => {
            deepTree(res.data.data)
            function deepTree(lists) {
                lists.forEach((item) => {
                    item.validName = item.valid == 0 ? '禁用' : '启用'
                    item.typeName = item.type == 0 ? '目录' : item.type == 1 ? '菜单' : '按钮'
                    if (item.children) {
                        deepTree(item.children)
                    }
                })
            }

            if (id) {
                whoOpen.value = [...whoOpen.value, ...findParentData(id, res.data.data, 'menuId')]
            }

            res.data.data.forEach((treeData) => {
                assignmentOpen(whoOpen.value, treeData, 'menuId')
            })

            treeData.lists = res.data.data
        })
    }

    //清空初始化的方法
    function initialization() {
        modalTypeData.value = '0'

        for (const item in catalogData) {
            catalogData[item].value = null
            catalogData[item].info = null
        }

        for (const item in menuData) {
            menuData[item].value = null
            menuData[item].info = null
        }

        for (const item in buttonData) {
            buttonData[item].value = null
            buttonData[item].info = null
        }
    }

    // 获取树级按钮列表
    function getMenuButtonTree() {
        const data: any = {
            method: 'GET',
            url: apiList.tree,
        }
        Server.Axios(data).then((res: any) => {
            catalogData.catalogSuperior.data = res.data.data
            menuData.menuSuperior.data = res.data.data
            buttonData.buttonSuperior.data = res.data.data
        })
    }

    //点击搜索
    function handleSearch(data) {
        getMenuTree()
    }

    //增加菜单
    const addFn = (() => {
        //点击增加弹窗时的操作
        const modalAddOpenBefore = (modalState) => {
            getMenuButtonTree()
            openModal(modalState.key, modalState.title)
        }
        // 添加的方法
        const addMenuFn = () => {
            const data: any = {
                method: 'POST',
                url: apiList.menu,
                config: {
                    data: {},
                },
            }

            data.config.data.type = modalTypeData.value
            switch (modalTypeData.value) {
                case '0':
                    data.config.data.menuName = catalogData.catalogTitle.value
                    data.config.data.url = catalogData.catalogRoute.value
                    data.config.data.valid = catalogData.catalogVisible.value
                    data.config.data.parentId = catalogData.catalogSuperior.value
                    data.config.data.sort = catalogData.catalogSort.value
                    data.config.data.icon = catalogData.catalogIcon.value
                    break
                case '1':
                    data.config.data.menuName = menuData.menuTitle.value
                    data.config.data.url = menuData.menuRoute.value
                    data.config.data.valid = menuData.menuVisible.value
                    data.config.data.parentId = menuData.menuSuperior.value
                    data.config.data.sort = menuData.menuSort.value
                    data.config.data.icon = menuData.menuIcon.value
                    break
                case '2':
                    data.config.data.menuName = buttonData.buttonTitle.value
                    data.config.data.url = buttonData.buttonId.value
                    data.config.data.parentId = buttonData.buttonSuperior.value
                    data.config.data.valid = buttonData.buttonVisible.value
                    data.config.data.sort = buttonData.buttonSort.value
                    break
            }

            Server.Axios(data).then((res: any) => {
                message.success('添加成功', 4)
                getMenuTree(res.data.data.menuId)
                cancelModal()
            })
        }

        return {
            modalAddOpenBefore,
            addMenuFn,
        }
    })()

    // 点击删除之前的操作
    function deleteBefore(item) {
        actionMenu(item, 'DELETE', apiList.menu)
    }

    // 点击禁用之前的操作
    function disableBefore(item) {
        actionMenu(item, 'PUT', apiList.menuForbidden)
    }

    // 删除菜单/禁用菜单
    function actionMenu(item, method, url) {
        Server.Axios({
            method,
            url: url + '/' + item.menuId,
        }).then((res: any) => {
            message.success('操作成功', 4)
            getMenuTree()
        })
    }

    //排序
    const dragFn = (() => {
        // 排序
        const onTreeDataChange = (list) => {
            if (screenData.menuName.value || screenData.menuName.valid) {
                return
            }
            Server.Axios({
                method: 'PUT',
                url: apiList.menuSort,
                config: {
                    data: { children: flatten(list) },
                },
            }).then((res: any) => {
                treeData.lists = list
            })
        }
        // 树结构扁平化
        function flatten(arr) {
            const result: any = []
            function flatten_inside(arr) {
                for (let i = 0; i < arr.length; i++) {
                    const item = arr[i]
                    result.push(item)
                    if (item.children && item.children.length > 0) {
                        flatten_inside(item.children)
                    }
                }
            }
            flatten_inside(arr)
            return result
        }

        //拖拽时的钩子
        function TreeDataChangeOver(e) {
            if (screenData.menuName.value || screenData.menuName.valid) {
                message.warning('搜索时不允许菜单拖动')
                return false
            }
            if (e.type === '2') {
                message.warning('按钮不允许拖拽')
                return false
            }
            return true
        }
        return { onTreeDataChange, TreeDataChangeOver }
    })()

    return {
        treeData, //菜单树数据
        modalTypeData, //弹窗类型 是目录还是按钮还是菜单
        catalogData, //目录数据
        menuData, //菜单数据
        buttonData, //按钮数据
        screenData, //筛选数据
        handleSearch, //点击查询按钮
        getMenuTree, //获取菜单树
        cancelModal, //取消弹窗
        modalState, //弹窗的状态
        addFn, //添加
        editFn, //修改
        dragFn, //拖动
        deleteBefore, //删除操作
        disableBefore, //禁用操作
    }
}

export { hooks }
